# Specfile for BZFlag-Admin

%define name	ksm-bzflag-admin
%define version	1.0.2
%define release	1.2.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _sysddir	/etc/systemd/system
%define _bindir		/usr/local/bin
%define _sbindir	/usr/local/sbin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}
%define _mapdir		/usr/share/games/bzflag/maps

Summary:	Admin Program for BZFlag
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Amusements/Games/3D/Shoot
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	bzflag
Requires:	ksm-lib-sh >= 3.0.2-0.4.0
#Provides:	sampled
#Conflicts:	sampled-other,libsample == 0.0.0
#Obsoletes:	mysampled

%description
This Package will enable the admin to manage the BZFlag server in a 
comfortable way. Some maps are included in /usr/share/games/bzflag/maps.

Please check/configure:
 /etc/sysconfig/ksm-bzflagserver
 /usr/local/etc/bzflag.conf

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#% makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/sample.conf
#%config %{_confdir}/sample.conf
#%config %{_scnfdir}/sample
%attr(600,root,root)%{_confdir}/bzflag.conf
%attr(600,root,root)%{_scnfdir}/ksm-bzflagserver

#%attr(744,root,root)%{_rcdir}/ksm-bzflagserver
#%attr(777,root,root)%{_bindir}/rcsampled
%attr(744,root,root)%{_sbindir}/ksm-bzflagserver.sh
%attr(700,root,root)%{_sbindir}/runksm-bzflagserver

%{_datadir}/RELEASE
%{_datadir}/VERSION
%attr(744,root,root)%{_datadir}/ksm-bzflagserver.rc
%{_datadir}/ksm-bzflagserver.service

#/usr/share/applications/sample.desktop
#%{_icondir}/16x16/apps/sample.png
#%{_icondir}/22x22/apps/sample.png
#%{_icondir}/32x32/apps/sample.png
#%{_icondir}/48x48/apps/sample.png
#%{_icondir}/64x64/apps/sample.png
#%{_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

#%docdir %{_man1dir}
#%{_man1dir}/sample.1.gz

%docdir %{_man8dir}
%{_man8dir}/ksm-bzflagserver.sh.8.gz
%{_man8dir}/runksm-bzflagserver.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#%{_docdir}/README.de

%{_mapdir}/alachua.bzw
%{_mapdir}/alderon.bzw
%{_mapdir}/arena.bzw
%{_mapdir}/badgerking.bzw
%{_mapdir}/bagdad.bzw
%{_mapdir}/camp_swampy.bzw
%{_mapdir}/djungel-hills.bzw
%{_mapdir}/giza-planet.bzw
%{_mapdir}/glasworld.bzw
%{_mapdir}/golden_gate-4.0.bzw
%{_mapdir}/helicopter-base.bzw
%{_mapdir}/laserCFT.bzw
%{_mapdir}/manhattan.bzw
%{_mapdir}/minas-thirit.bzw
%{_mapdir}/mystic-valley.bzw
%{_mapdir}/playground.bzw
%{_mapdir}/reality_disfunction.bzw
%{_mapdir}/silent_death.bzw
%{_mapdir}/spirals.bzw
%{_mapdir}/teleport.bzw
%{_mapdir}/testworld.bzw
%{_mapdir}/urbancombat.bzw
%{_mapdir}/zion.bzw

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# backup config files
test -e %{_confdir}/bzflag.conf && cp %{_confdir}/bzflag.conf %{_confdir}/bzflag.conf.rpmsave
test -e %{_scnfdir}/ksm-bzflagserver && cp %{_scnfdir}/ksm-bzflagserver %{_scnfdir}/ksm-bzflagserver.rpmsave

# disable sampled
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
test -e %{_bindir}/rcksm-bzflagserver && rm -f %{_bindir}/rcksm-bzflagserver

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - uninstall KSM-BZFlag-Admin
if [ -d %{_sysddir} ]; then				# systemd
	if [ -e %{_sysddir}/ksm-bzflagserver.service ]; then
		systemctl stop ksm-bzflagserver.service
		systemctl disable ksm-bzflagserver.service
		rm %{_sysddir}/ksm-bzflagserver.service
		systemctl daemon-reload
	fi
else							# SysV init
	test -x %{_rcdir}/ksm-bzflagserver && %{_rcdir}/ksm-bzflagserver stop > /dev/null 2>&1
	insserv -r ksm-bzflagserver
	rm -f %{_rcdir}/ksm-bzflagserver
	rm -f %{_bindir}/rcksm-bzflagserver
fi

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# check global conf bzflag.conf
cf=%{_confdir}/bzflag.conf
if [ -e $cf.rpmsave ]; then
	diff $cf $cf.rpmsave > /dev/null 2>&1
	ret=$?
	if [ "$ret" -eq 0 ]; then
		rm $cf.rpmsave
	else
		echo "Check $cf"
	fi
else
	echo "Configure $cf"
fi

# set config pathname and all config vars from new config file
cf=%{_scnfdir}/ksm-bzflagserver
cnfvars='BZFLAGSERVER_WORLD BZFLAGSERVER_OPTS BZFLAGSERVER_OPTSR BZFLAGSERVER_SRVMSG BZFLAGSERVER_ADMSG BZFLAGSERVER_PUBLIC BZFLAGSERVER_PORT BZFLAGSERVER_NEWBIES BZFLAGSERVER_DISABLEBOTS' # all vars from new conf

c='' s='' t='' cnt=0 i=0 ret=0
cfu='' cfut=''

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

# INIT SCRIPT/SYSTEMD UNIT - install KSM-BZFlag-Admin
if [ -d %{_sysddir} ]; then				# systemd
	cp --preserve=mode %{_datadir}/ksm-bzflagserver.service %{_sysddir}/
	systemctl daemon-reload
	systemctl enable ksm-bzflagserver.service

	echo "The unit is already added to the bootprocess."
	echo "Next configure the $cf"
	echo "If wanted start it within yast or manual with:"
	echo "runksm-bzflagserver --start"
else							# SysV init
	cp --preserve=mode %{_datadir}/ksm-bzflagserver.rc %{_rcdir}/ksm-bzflagserver
	ln -sf %{_rcdir}/ksm-bzflagserver %{_bindir}/rcksm-bzflagserver
	insserv ksm-bzflagserver

	echo "The script is already added to the bootprocess."
	echo "Next configure the $cf"
	echo "If wanted start it within yast or manual with:"
	echo "rcksm-bzflagserver start"
fi

if [ "$1" == 1 ]; then					# install package
	# install bzflag.conf.01
	cfu=%{_confdir}/bzflag.conf.01
	cfut=%{_confdir}/bzflag.conf
	if [ ! -e $cfu ]; then
		cp $cfut $cfu
		chmod 600 $cfu
		echo "Please configure $cfu"
	fi

	echo "Configure $cf"
#	echo "Users must create HOME/.samplerc with update-sample"
else							# upgrade package
	# update global conf
	if [ -e $cf.rpmsave ]; then
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
		else
			echo "Error - cmd replcnfvar not found or not executable!" >&2
			echo "Conf file not updated!" >&2
		fi

#		# update array vars MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				# array MainArr
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi

		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Please check $cf"
		fi
	fi
#
#	echo "If new version then users must update HOME/.samplerc with update-sample"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	# backup config files
	test -e %{_confdir}/bzflag.conf && cp %{_confdir}/bzflag.conf %{_confdir}/bzflag.conf.rpmsave
	test -e %{_scnfdir}/ksm-bzflagserver && cp %{_scnfdir}/ksm-bzflagserver %{_scnfdir}/ksm-bzflagserver.rpmsave

	# disable sampled
	#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	test -e %{_bindir}/rcksm-bzflagserver && rm -f %{_bindir}/rcksm-bzflagserver

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/sample.directory \
	#	/usr/share/applications/sample.desktop \
	#	/usr/share/applications/sample-admin.desktop

	# INIT SCRIPT/SYSTEMD UNIT - uninstall KSM-BZFlag-Admin
	if [ -d %{_sysddir} ]; then				# systemd
		if [ -e %{_sysddir}/ksm-bzflagserver.service ]; then
			systemctl stop ksm-bzflagserver.service
			systemctl disable ksm-bzflagserver.service
			rm %{_sysddir}/ksm-bzflagserver.service
			systemctl daemon-reload
		fi
	else							# SysV init
		test -x %{_rcdir}/ksm-bzflagserver && %{_rcdir}/ksm-bzflagserver stop > /dev/null 2>&1
		insserv -r ksm-bzflagserver
		rm -f %{_rcdir}/ksm-bzflagserver
		rm -f %{_bindir}/rcksm-bzflagserver
	fi
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/sampledir
#else							# upgrade package
fi
exit 0

%changelog
* Tue Oct 03 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.2-1.2.0
- The package has been revised.

* Mon Oct 02 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.2-1.1.0
- The rpm scriptlets have been revised.

* Wed Sep 27 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.2-1.0.0
- Removed ksm-bzflagserver.cmd
- The whole systemd stuff has been revised.

* Sun Sep 24 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.2-0.0.0
- Now we have systemd support.
  The package installs different on a
  systemd system than on a SystemV init system.
- Added for systemd support:
  a) ksm-bzflagserver.sh (the component which does
     the work - like the init-script ksm-bzflagserver).
  b) runksm-bzflagserver - the control program for
     the bzflag server startup (should only be used
     on a systemd system!).

* Thu Apr 27 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.2.0
- The RC-Script has been revised.

* Tue Nov 08 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.1.0
- The rc-script /etc/init.d/ksm-bzflagserver
  has been revised.

* Fri Sep 26 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.0.1
- The docu of the package has been revised.

* Fri Sep 26 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.0.0
- The package has been revised.

* Thu Nov 08 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.2.0
- The package has been revised.

* Fri Apr 27 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0
- The config update process has been revised.

* Mon Apr 02 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.2
- The release naming scheme has changed ('.ksm' is removed).

* Thu Jan 06 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.2.ksm
- The RPM scriptlets are corrected.

* Mon Jan 03 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.1.ksm
- The package name has changed to avoid conflicts with the openSUSE
  distribution. It has been prepended with 'ksm-'.

* Tue Apr 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.1.ksm
- The configuration of map alachua.bzw has changed.

* Fri Apr 23 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.0.ksm
- Multiple map files are introduced.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.3.ksm
- The docu has changed.

* Fri Jan 15 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.2.ksm
- The package name (Release) has changed.

* Thu Nov 19 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.ksm.0.1
- The RPM scriptlets are corrected.

* Mon Oct 26 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0
- The Package management has changed to RPM.
